/*
 * Copyright 2009-2010 the Fess Project and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */

package jp.sf.fess.db.cbean.bs;

import jp.sf.fess.db.allcommon.DBFluteConfig;
import jp.sf.fess.db.allcommon.DBMetaInstanceHandler;
import jp.sf.fess.db.allcommon.ImplementedInvokerAssistant;
import jp.sf.fess.db.allcommon.ImplementedSqlClauseCreator;
import jp.sf.fess.db.cbean.FailureUrlCB;
import jp.sf.fess.db.cbean.FileCrawlingConfigCB;
import jp.sf.fess.db.cbean.WebCrawlingConfigCB;
import jp.sf.fess.db.cbean.cq.FailureUrlCQ;
import jp.sf.fess.db.cbean.cq.FileCrawlingConfigCQ;
import jp.sf.fess.db.cbean.cq.WebCrawlingConfigCQ;
import jp.sf.fess.db.cbean.nss.FileCrawlingConfigNss;
import jp.sf.fess.db.cbean.nss.WebCrawlingConfigNss;

import org.seasar.dbflute.cbean.AbstractConditionBean;
import org.seasar.dbflute.cbean.ConditionBean;
import org.seasar.dbflute.cbean.ConditionQuery;
import org.seasar.dbflute.cbean.OrQuery;
import org.seasar.dbflute.cbean.SpecifyQuery;
import org.seasar.dbflute.cbean.SubQuery;
import org.seasar.dbflute.cbean.UnionQuery;
import org.seasar.dbflute.cbean.chelper.HpAbstractSpecification;
import org.seasar.dbflute.cbean.chelper.HpCBPurpose;
import org.seasar.dbflute.cbean.chelper.HpCalculator;
import org.seasar.dbflute.cbean.chelper.HpColQyHandler;
import org.seasar.dbflute.cbean.chelper.HpColQyOperand;
import org.seasar.dbflute.cbean.chelper.HpSpQyCall;
import org.seasar.dbflute.cbean.sqlclause.SqlClause;
import org.seasar.dbflute.cbean.sqlclause.SqlClauseCreator;
import org.seasar.dbflute.dbmeta.DBMetaProvider;
import org.seasar.dbflute.twowaysql.factory.SqlAnalyzerFactory;

/**
 * The base condition-bean of FAILURE_URL.
 * @author DBFlute(AutoGenerator)
 */
public class BsFailureUrlCB extends AbstractConditionBean {

    // ===================================================================================
    //                                                                           Attribute
    //                                                                           =========
    protected FailureUrlCQ _conditionQuery;

    // ===================================================================================
    //                                                                           SqlClause
    //                                                                           =========
    @Override
    protected SqlClause createSqlClause() {
        SqlClauseCreator creator = DBFluteConfig.getInstance()
                .getSqlClauseCreator();
        if (creator != null) {
            return creator.createSqlClause(this);
        }
        return new ImplementedSqlClauseCreator().createSqlClause(this); // as default
    }

    // ===================================================================================
    //                                                                     DBMeta Provider
    //                                                                     ===============
    @Override
    protected DBMetaProvider getDBMetaProvider() {
        return new DBMetaInstanceHandler(); // as default
    }

    // ===================================================================================
    //                                                                          Table Name
    //                                                                          ==========
    public String getTableDbName() {
        return "FAILURE_URL";
    }

    // ===================================================================================
    //                                                                 PrimaryKey Handling
    //                                                                 ===================
    public void acceptPrimaryKey(Long id) {
        assertObjectNotNull("id", id);
        BsFailureUrlCB cb = this;
        cb.query().setId_Equal(id);
    }

    public ConditionBean addOrderBy_PK_Asc() {
        query().addOrderBy_Id_Asc();
        return this;
    }

    public ConditionBean addOrderBy_PK_Desc() {
        query().addOrderBy_Id_Desc();
        return this;
    }

    // ===================================================================================
    //                                                                               Query
    //                                                                               =====
    /**
     * Prepare for various queries. <br />
     * Examples of main functions are following:
     * <pre>
     * <span style="color: #3F7E5E">// Basic Queries</span>
     * cb.query().setMemberId_Equal(value);        <span style="color: #3F7E5E">// =</span>
     * cb.query().setMemberId_NotEqual(value);     <span style="color: #3F7E5E">// !=</span>
     * cb.query().setMemberId_GreaterThan(value);  <span style="color: #3F7E5E">// &gt;</span>
     * cb.query().setMemberId_LessThan(value);     <span style="color: #3F7E5E">// &lt;</span>
     * cb.query().setMemberId_GreaterEqual(value); <span style="color: #3F7E5E">// &gt;=</span>
     * cb.query().setMemberId_LessEqual(value);    <span style="color: #3F7E5E">// &lt;=</span>
     * cb.query().setMemberName_InScope(valueList);    <span style="color: #3F7E5E">// in ('a', 'b')</span>
     * cb.query().setMemberName_NotInScope(valueList); <span style="color: #3F7E5E">// not in ('a', 'b')</span>
     * cb.query().setMemberName_PrefixSearch(value);   <span style="color: #3F7E5E">// like 'a%' escape '|'</span>
     * <span style="color: #3F7E5E">// LikeSearch with various options: (versatile)</span>
     * <span style="color: #3F7E5E">// {like ... [options]}</span>
     * cb.query().setMemberName_LikeSearch(value, option);
     * cb.query().setMemberName_NotLikeSearch(value, option); <span style="color: #3F7E5E">// not like ...</span>
     * <span style="color: #3F7E5E">// FromTo with various options: (versatile)</span>
     * <span style="color: #3F7E5E">// {(default) fromDatetime &lt;= BIRTHDATE &lt;= toDatetime}</span>
     * cb.query().setBirthdate_FromTo(fromDatetime, toDatetime, option);
     * <span style="color: #3F7E5E">// DateFromTo: (Date means yyyy/MM/dd)</span>
     * <span style="color: #3F7E5E">// {fromDate &lt;= BIRTHDATE &lt; toDate + 1 day}</span>
     * cb.query().setBirthdate_DateFromTo(fromDate, toDate);
     * cb.query().setBirthdate_IsNull();    <span style="color: #3F7E5E">// is null</span>
     * cb.query().setBirthdate_IsNotNull(); <span style="color: #3F7E5E">// is not null</span>
     * 
     * <span style="color: #3F7E5E">// ExistsReferrer: (co-related sub-query)</span>
     * <span style="color: #3F7E5E">// {where exists (select PURCHASE_ID from PURCHASE where ...)}</span>
     * cb.query().existsPurchaseList(new SubQuery&lt;PurchaseCB&gt;() {
     *     public void query(PurchaseCB subCB) {
     *         subCB.query().setXxx... <span style="color: #3F7E5E">// referrer sub-query condition</span>
     *     }
     * });
     * cb.query().notExistsPurchaseList...
     * 
     * <span style="color: #3F7E5E">// InScopeRelation: (sub-query)</span>
     * <span style="color: #3F7E5E">// {where MEMBER_STATUS_CODE in (select MEMBER_STATUS_CODE from MEMBER_STATUS where ...)}</span>
     * cb.query().inScopeMemberStatus(new SubQuery&lt;MemberStatusCB&gt;() {
     *     public void query(MemberStatusCB subCB) {
     *         subCB.query().setXxx... <span style="color: #3F7E5E">// relation sub-query condition</span>
     *     }
     * });
     * cb.query().notInScopeMemberStatus...
     * 
     * <span style="color: #3F7E5E">// (Query)DerivedReferrer: (co-related sub-query)</span>
     * cb.query().derivedPurchaseList().max(new SubQuery&lt;PurchaseCB&gt;() {
     *     public void query(PurchaseCB subCB) {
     *         subCB.specify().columnPurchasePrice(); <span style="color: #3F7E5E">// derived column for function</span>
     *         subCB.query().setXxx... <span style="color: #3F7E5E">// referrer sub-query condition</span>
     *     }
     * }).greaterEqual(value);
     * 
     * <span style="color: #3F7E5E">// ScalarCondition: (self-table sub-query)</span>
     * cb.query().scalar_Equal().max(new SubQuery&lt;MemberCB&gt;() {
     *     public void query(MemberCB subCB) {
     *         subCB.specify().columnBirthdate(); <span style="color: #3F7E5E">// derived column for function</span>
     *         subCB.query().setXxx... <span style="color: #3F7E5E">// scalar sub-query condition</span>
     *     }
     * });
     * 
     * <span style="color: #3F7E5E">// OrderBy</span>
     * cb.query().addOrderBy_MemberName_Asc();
     * cb.query().addOrderBy_MemberName_Desc().withManualOrder(valueList);
     * cb.query().addOrderBy_MemberName_Desc().withNullsFirst();
     * cb.query().addOrderBy_MemberName_Desc().withNullsLast();
     * cb.query().addSpecifiedDerivedOrderBy_Desc(aliasName);
     * 
     * <span style="color: #3F7E5E">// Query(Relation)</span>
     * cb.query().queryMemberStatus()...;
     * cb.query().queryMemberAddressAsValid(targetDate)...;
     * </pre>
     * @return The instance of condition-query for base-point table to set up query. (NotNull)
     */
    public FailureUrlCQ query() {
        return getConditionQuery();
    }

    public FailureUrlCQ getConditionQuery() { // public for parameter comment
        assertQueryPurpose();
        if (_conditionQuery == null) {
            _conditionQuery = createLocalCQ();
        }
        return _conditionQuery;
    }

    protected FailureUrlCQ createLocalCQ() {
        return xcreateCQ(null, getSqlClause(), getSqlClause()
                .getLocalTableAliasName(), 0);
    }

    protected FailureUrlCQ xcreateCQ(ConditionQuery childQuery,
            SqlClause sqlClause, String aliasName, int nestLevel) {
        return new FailureUrlCQ(childQuery, sqlClause, aliasName, nestLevel);
    }

    public ConditionQuery localCQ() {
        return getConditionQuery();
    }

    // ===================================================================================
    //                                                                               Union
    //                                                                               =====
    /**
     * Set up 'union' for base-point table. <br />
     * You don't need to call SetupSelect in union-query,
     * because it inherits calls before. (Don't call SetupSelect after here)
     * <pre>
     * cb.query().<span style="color: #FD4747">union</span>(new UnionQuery&lt;FailureUrlCB&gt;() {
     *     public void query(FailureUrlCB unionCB) {
     *         unionCB.query().setXxx...
     *     }
     * });
     * </pre>
     * @param unionQuery The query of 'union'. (NotNull)
     */
    public void union(UnionQuery<FailureUrlCB> unionQuery) {
        final FailureUrlCB cb = new FailureUrlCB();
        cb.xsetupForUnion();
        xsyncUQ(cb);
        unionQuery.query(cb);
        final FailureUrlCQ cq = cb.query();
        query().xsetUnionQuery(cq);
    }

    /**
     * Set up 'union all' for base-point table. <br />
     * You don't need to call SetupSelect in union-query,
     * because it inherits calls before. (Don't call SetupSelect after here)
     * <pre>
     * cb.query().<span style="color: #FD4747">unionAll</span>(new UnionQuery&lt;FailureUrlCB&gt;() {
     *     public void query(FailureUrlCB unionCB) {
     *         unionCB.query().setXxx...
     *     }
     * });
     * </pre>
     * @param unionQuery The query of 'union all'. (NotNull)
     */
    public void unionAll(UnionQuery<FailureUrlCB> unionQuery) {
        final FailureUrlCB cb = new FailureUrlCB();
        cb.xsetupForUnion();
        xsyncUQ(cb);
        unionQuery.query(cb);
        final FailureUrlCQ cq = cb.query();
        query().xsetUnionAllQuery(cq);
    }

    // ===================================================================================
    //                                                                         SetupSelect
    //                                                                         ===========
    protected FileCrawlingConfigNss _nssFileCrawlingConfig;

    public FileCrawlingConfigNss getNssFileCrawlingConfig() {
        if (_nssFileCrawlingConfig == null) {
            _nssFileCrawlingConfig = new FileCrawlingConfigNss(null);
        }
        return _nssFileCrawlingConfig;
    }

    /**
     * Set up relation columns to select clause. <br />
     * FILE_CRAWLING_CONFIG as 'fileCrawlingConfig'.
     * <pre>
     * FailureUrlCB cb = new FailureUrlCB();
     * cb.<span style="color: #FD4747">setupSelect_FileCrawlingConfig()</span>; <span style="color: #3F7E5E">// ...().with[nested-relation]()</span>
     * cb.query().setFoo...(value);
     * FailureUrl failureUrl = failureUrlBhv.selectEntityWithDeletedCheck(cb);
     * ... = failureUrl.<span style="color: #FD4747">getFileCrawlingConfig()</span>; <span style="color: #3F7E5E">// you can get by using SetupSelect</span>
     * </pre>
     * @return The set-upper of nested relation. {setupSelect...().with[nested-relation]} (NotNull)
     */
    public FileCrawlingConfigNss setupSelect_FileCrawlingConfig() {
        if (hasSpecifiedColumn()) { // if reverse call
            specify().columnFileConfigId();
        }
        doSetupSelect(new SsCall() {
            public ConditionQuery qf() {
                return query().queryFileCrawlingConfig();
            }
        });
        if (_nssFileCrawlingConfig == null
                || !_nssFileCrawlingConfig.hasConditionQuery()) {
            _nssFileCrawlingConfig = new FileCrawlingConfigNss(query()
                    .queryFileCrawlingConfig());
        }
        return _nssFileCrawlingConfig;
    }

    protected WebCrawlingConfigNss _nssWebCrawlingConfig;

    public WebCrawlingConfigNss getNssWebCrawlingConfig() {
        if (_nssWebCrawlingConfig == null) {
            _nssWebCrawlingConfig = new WebCrawlingConfigNss(null);
        }
        return _nssWebCrawlingConfig;
    }

    /**
     * Set up relation columns to select clause. <br />
     * WEB_CRAWLING_CONFIG as 'webCrawlingConfig'.
     * <pre>
     * FailureUrlCB cb = new FailureUrlCB();
     * cb.<span style="color: #FD4747">setupSelect_WebCrawlingConfig()</span>; <span style="color: #3F7E5E">// ...().with[nested-relation]()</span>
     * cb.query().setFoo...(value);
     * FailureUrl failureUrl = failureUrlBhv.selectEntityWithDeletedCheck(cb);
     * ... = failureUrl.<span style="color: #FD4747">getWebCrawlingConfig()</span>; <span style="color: #3F7E5E">// you can get by using SetupSelect</span>
     * </pre>
     * @return The set-upper of nested relation. {setupSelect...().with[nested-relation]} (NotNull)
     */
    public WebCrawlingConfigNss setupSelect_WebCrawlingConfig() {
        if (hasSpecifiedColumn()) { // if reverse call
            specify().columnWebConfigId();
        }
        doSetupSelect(new SsCall() {
            public ConditionQuery qf() {
                return query().queryWebCrawlingConfig();
            }
        });
        if (_nssWebCrawlingConfig == null
                || !_nssWebCrawlingConfig.hasConditionQuery()) {
            _nssWebCrawlingConfig = new WebCrawlingConfigNss(query()
                    .queryWebCrawlingConfig());
        }
        return _nssWebCrawlingConfig;
    }

    // [DBFlute-0.7.4]
    // ===================================================================================
    //                                                                             Specify
    //                                                                             =======
    protected HpSpecification _specification;

    /**
     * Prepare for SpecifyColumn, (Specify)DerivedReferrer. <br />
     * This method should be called after SetupSelect.
     * <pre>
     * cb.setupSelect_MemberStatus(); <span style="color: #3F7E5E">// should be called before specify()</span>
     * cb.specify().columnMemberName();
     * cb.specify().specifyMemberStatus().columnMemberStatusName();
     * cb.specify().derivedPurchaseList().max(new SubQuery&lt;PurchaseCB&gt;() {
     *     public void query(PurchaseCB subCB) {
     *         subCB.specify().columnPurchaseDatetime();
     *         subCB.query().set...
     *     }
     * }, aliasName);
     * </pre>
     * @return The instance of specification. (NotNull)
     */
    public HpSpecification specify() {
        assertSpecifyPurpose();
        if (_specification == null) {
            _specification = new HpSpecification(this,
                    new HpSpQyCall<FailureUrlCQ>() {
                        public boolean has() {
                            return true;
                        }

                        public FailureUrlCQ qy() {
                            return query();
                        }
                    }, _purpose, getDBMetaProvider());
        }
        return _specification;
    }

    protected boolean hasSpecifiedColumn() {
        return _specification != null
                && _specification.isAlreadySpecifiedRequiredColumn();
    }

    protected HpAbstractSpecification<? extends ConditionQuery> localSp() {
        return specify();
    }

    public static class HpSpecification extends
            HpAbstractSpecification<FailureUrlCQ> {
        protected FileCrawlingConfigCB.HpSpecification _fileCrawlingConfig;

        protected WebCrawlingConfigCB.HpSpecification _webCrawlingConfig;

        public HpSpecification(ConditionBean baseCB,
                HpSpQyCall<FailureUrlCQ> qyCall, HpCBPurpose purpose,
                DBMetaProvider dbmetaProvider) {
            super(baseCB, qyCall, purpose, dbmetaProvider);
        }

        /** ID: {PK, ID, NotNull, BIGINT(19)} */
        public void columnId() {
            doColumn("ID");
        }

        /** URL: {IX, NotNull, VARCHAR(4000)} */
        public void columnUrl() {
            doColumn("URL");
        }

        /** THREAD_NAME: {NotNull, VARCHAR(30)} */
        public void columnThreadName() {
            doColumn("THREAD_NAME");
        }

        /** ERROR_NAME: {IX+, VARCHAR(255)} */
        public void columnErrorName() {
            doColumn("ERROR_NAME");
        }

        /** ERROR_LOG: {VARCHAR(4000)} */
        public void columnErrorLog() {
            doColumn("ERROR_LOG");
        }

        /** ERROR_COUNT: {IX+, NotNull, INTEGER(10)} */
        public void columnErrorCount() {
            doColumn("ERROR_COUNT");
        }

        /** LAST_ACCESS_TIME: {IX+, NotNull, TIMESTAMP(23, 10)} */
        public void columnLastAccessTime() {
            doColumn("LAST_ACCESS_TIME");
        }

        /** WEB_CONFIG_ID: {IX, BIGINT(19), FK to WEB_CRAWLING_CONFIG} */
        public void columnWebConfigId() {
            doColumn("WEB_CONFIG_ID");
        }

        /** FILE_CONFIG_ID: {IX, BIGINT(19), FK to FILE_CRAWLING_CONFIG} */
        public void columnFileConfigId() {
            doColumn("FILE_CONFIG_ID");
        }

        @Override
        protected void doSpecifyRequiredColumn() {
            columnId(); // PK
            if (_qyCall.qy().hasConditionQueryFileCrawlingConfig()
                    || _qyCall.qy().getReferrerQuery() instanceof FileCrawlingConfigCQ) {
                columnFileConfigId(); // FK or one-to-one referrer
            }
            if (_qyCall.qy().hasConditionQueryWebCrawlingConfig()
                    || _qyCall.qy().getReferrerQuery() instanceof WebCrawlingConfigCQ) {
                columnWebConfigId(); // FK or one-to-one referrer
            }
        }

        @Override
        protected String getTableDbName() {
            return "FAILURE_URL";
        }

        /**
         * Prepare to specify functions about relation table. <br />
         * FILE_CRAWLING_CONFIG as 'fileCrawlingConfig'.
         * @return The instance for specification for relation table to specify. (NotNull)
         */
        public FileCrawlingConfigCB.HpSpecification specifyFileCrawlingConfig() {
            assertRelation("fileCrawlingConfig");
            if (_fileCrawlingConfig == null) {
                _fileCrawlingConfig = new FileCrawlingConfigCB.HpSpecification(
                        _baseCB, new HpSpQyCall<FileCrawlingConfigCQ>() {
                            public boolean has() {
                                return _qyCall.has()
                                        && _qyCall
                                                .qy()
                                                .hasConditionQueryFileCrawlingConfig();
                            }

                            public FileCrawlingConfigCQ qy() {
                                return _qyCall.qy().queryFileCrawlingConfig();
                            }
                        }, _purpose, _dbmetaProvider);
            }
            return _fileCrawlingConfig;
        }

        /**
         * Prepare to specify functions about relation table. <br />
         * WEB_CRAWLING_CONFIG as 'webCrawlingConfig'.
         * @return The instance for specification for relation table to specify. (NotNull)
         */
        public WebCrawlingConfigCB.HpSpecification specifyWebCrawlingConfig() {
            assertRelation("webCrawlingConfig");
            if (_webCrawlingConfig == null) {
                _webCrawlingConfig = new WebCrawlingConfigCB.HpSpecification(
                        _baseCB, new HpSpQyCall<WebCrawlingConfigCQ>() {
                            public boolean has() {
                                return _qyCall.has()
                                        && _qyCall
                                                .qy()
                                                .hasConditionQueryWebCrawlingConfig();
                            }

                            public WebCrawlingConfigCQ qy() {
                                return _qyCall.qy().queryWebCrawlingConfig();
                            }
                        }, _purpose, _dbmetaProvider);
            }
            return _webCrawlingConfig;
        }
    }

    // [DBFlute-0.9.5.3]
    // ===================================================================================
    //                                                                         ColumnQuery
    //                                                                         ===========
    /**
     * Set up column-query. {column1 = column2}
     * <pre>
     * <span style="color: #3F7E5E">// where FOO &lt; BAR</span>
     * cb.<span style="color: #FD4747">columnQuery</span>(new SpecifyQuery&lt;FailureUrlCB&gt;() {
     *     public void query(FailureUrlCB cb) {
     *         cb.specify().<span style="color: #FD4747">columnFoo()</span>; <span style="color: #3F7E5E">// left column</span>
     *     }
     * }).lessThan(new SpecifyQuery&lt;FailureUrlCB&gt;() {
     *     public void query(FailureUrlCB cb) {
     *         cb.specify().<span style="color: #FD4747">columnBar()</span>; <span style="color: #3F7E5E">// right column</span>
     *     }
     * }); <span style="color: #3F7E5E">// you can calculate for right column like '}).plus(3);'</span>
     * </pre>
     * @param leftSpecifyQuery The specify-query for left column. (NotNull)
     * @return The object for setting up operand and right column. (NotNull)
     */
    public HpColQyOperand<FailureUrlCB> columnQuery(
            final SpecifyQuery<FailureUrlCB> leftSpecifyQuery) {
        return new HpColQyOperand<FailureUrlCB>(
                new HpColQyHandler<FailureUrlCB>() {
                    public HpCalculator handle(
                            SpecifyQuery<FailureUrlCB> rightSp, String operand) {
                        return xcolqy(xcreateColumnQueryCB(),
                                xcreateColumnQueryCB(), leftSpecifyQuery,
                                rightSp, operand);
                    }
                });
    }

    protected FailureUrlCB xcreateColumnQueryCB() {
        FailureUrlCB cb = new FailureUrlCB();
        cb.xsetupForColumnQuery((FailureUrlCB) this);
        return cb;
    }

    // [DBFlute-0.9.6.3]
    // ===================================================================================
    //                                                                        OrScopeQuery
    //                                                                        ============
    /**
     * Set up the query for or-scope.
     * <pre>
     * <span style="color: #3F7E5E">// where (FOO = '...' or BAR = '...')</span>
     * cb.<span style="color: #FD4747">orScopeQuery</span>(new OrQuery&lt;FailureUrlCB&gt;() {
     *     public void query(FailureUrlCB orCB) {
     *         orCB.query().setFOO_Equal...
     *         orCB.query().setBAR_Equal...
     *     }
     * });
     * </pre>
     * @param orQuery The query for or-condition. (NotNull)
     */
    public void orScopeQuery(OrQuery<FailureUrlCB> orQuery) {
        xorSQ((FailureUrlCB) this, orQuery);
    }

    // ===================================================================================
    //                                                                          DisplaySQL
    //                                                                          ==========
    @Override
    protected SqlAnalyzerFactory getSqlAnalyzerFactory() {
        return new ImplementedInvokerAssistant().assistSqlAnalyzerFactory();
    }

    @Override
    protected String getLogDateFormat() {
        return DBFluteConfig.getInstance().getLogDateFormat();
    }

    @Override
    protected String getLogTimestampFormat() {
        return DBFluteConfig.getInstance().getLogTimestampFormat();
    }

    // ===================================================================================
    //                                                          Basic Status Determination
    //                                                          ==========================
    public boolean hasUnionQueryOrUnionAllQuery() {
        return query().hasUnionQueryOrUnionAllQuery();
    }

    // [DBFlute-0.7.4]
    // ===================================================================================
    //                                                                        Purpose Type
    //                                                                        ============
    public void xsetupForColumnQuery(final FailureUrlCB cb) {
        xchangePurposeSqlClause(HpCBPurpose.COLUMN_QUERY);

        // inherits a parent query to synchronize real name
        // (and also for suppressing query check) 
        specify().xswitchQyCall(new HpSpQyCall<FailureUrlCQ>() {
            public boolean has() {
                return true;
            }

            public FailureUrlCQ qy() {
                return cb.query();
            }
        });
    }

    public void xsetupForVaryingUpdate() {
        xchangePurposeSqlClause(HpCBPurpose.VARYING_UPDATE);

        // for suppressing query check
        final FailureUrlCB nonCheckCB = new FailureUrlCB();
        specify().xswitchQyCall(new HpSpQyCall<FailureUrlCQ>() {
            public boolean has() {
                return true;
            }

            public FailureUrlCQ qy() {
                return nonCheckCB.query();
            }
        });
    }

    // ===================================================================================
    //                                                                            Internal
    //                                                                            ========
    // very internal (for suppressing warn about 'Not Use Import')
    protected String getConditionBeanClassNameInternally() {
        return FailureUrlCB.class.getName();
    }

    protected String getConditionQueryClassNameInternally() {
        return FailureUrlCQ.class.getName();
    }

    protected String getSubQueryClassNameInternally() {
        return SubQuery.class.getName();
    }
}
